import React from 'react';
import { FixedType } from './ColumnResizeHandler';
import { InnerCellProps } from './Cell';
import { RowDataType, RowKeyType } from './@types/common';
export interface HeaderCellProps<Row extends RowDataType, Key extends RowKeyType> extends Omit<InnerCellProps<Row, Key>, 'onResize'> {
    index?: number;
    minWidth?: number;
    sortColumn?: string;
    sortType?: 'desc' | 'asc';
    sortable?: boolean;
    resizable?: boolean;
    groupHeader?: boolean;
    flexGrow?: number;
    fixed?: boolean | 'left' | 'right';
    children: React.ReactNode;
    onResize?: (columnWidth?: number, dataKey?: string) => void;
    onSortColumn?: (dataKey?: string) => void;
    onColumnResizeStart?: (columnWidth?: number, left?: number, fixed?: boolean) => void;
    onColumnResizeMove?: (columnWidth?: number, columnLeft?: number, columnFixed?: FixedType) => void;
    onColumnResizeEnd?: (columnWidth?: number, cursorDelta?: number, dataKey?: any, index?: number) => void;
    renderSortIcon?: (sortType?: 'desc' | 'asc') => React.ReactNode;
}
declare const _default: <Row extends RowDataType, Key extends RowKeyType>(props: HeaderCellProps<Row, Key> & React.RefAttributes<HTMLDivElement>) => React.ReactElement;
export default _default;
